package com.taboola.flutter;

import android.content.Context;
import android.content.pm.PackageManager;

import java.util.HashMap;

public class TBLPackgeInfo {
    private final Context mContext;
    private int PackageInfoFlags = 0;
    private static final String appNameKey = "appName";
    private static final String packageNameKey = "packageName";
    private static final String versionKey = "version";

    public TBLPackgeInfo(Context context) {
        mContext = context;
    }

    public HashMap<String, String> getAll() {
        HashMap<String, String> packageInfoMap = new HashMap<>();
        try {
            String packageName = mContext.getPackageName();
            android.content.pm.PackageInfo packageInfo;
            if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.TIRAMISU) {
                packageInfo = mContext.getPackageManager().getPackageInfo(packageName, PackageManager.PackageInfoFlags.of(PackageInfoFlags));
            } else {
                packageInfo = mContext.getPackageManager().getPackageInfo(packageName, PackageInfoFlags);
            }

            packageInfoMap.put(appNameKey, mContext.getApplicationInfo().loadLabel(mContext.getPackageManager()).toString());
            packageInfoMap.put(packageNameKey, packageName);
            packageInfoMap.put(versionKey, packageInfo.versionName);

        } catch (PackageManager.NameNotFoundException e) {
            e.printStackTrace();
        }

        return packageInfoMap;
    }

}
