import 'package:flutter/material.dart';

import 'package:taboola_sdk/taboola.dart';
import 'package:taboola_sdk/classic/taboola_classic_listener.dart';
import 'package:taboola_sdk/classic/taboola_classic.dart';
import 'package:taboola_sdk_example/DefaultProperties.dart'
    as PublisherProperties;

TaboolaClassicBuilder taboolaClassicBuilder = Taboola.getTaboolaClassicBuilder(
    PublisherProperties.pageUrl, PublisherProperties.pageType);

int taboolaWidgetIndex = 5;
int taboolaFeedIndex = 9;

final List<String> items = List.generate(10, (index) => "Item $index");

class CustomListViewPageFeedAndWidget extends StatelessWidget {
  final bool isKeepAlive;

  const CustomListViewPageFeedAndWidget({Key? key, required this.isKeepAlive})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    final ScrollController _scrollController = ScrollController();

    Taboola.init(PublisherInfo(PublisherProperties.publisher));

    return Scaffold(
      body: ListView.builder(
        controller: _scrollController,
        itemCount: items.length,
        itemBuilder: (BuildContext context, int index) {
          return setContainer(index, _scrollController, isKeepAlive);
        },
      ),
    );
  }
}

Container setContainer(int index, scroll, isKeepAlive) {
  if (index == taboolaWidgetIndex) {
    return Container(
        color: Colors.teal[100 * (index % 9)],
        child: setListContent(index, scroll, isKeepAlive));
  } else if (index == taboolaFeedIndex) {
    return Container(
        color: Colors.teal[100 * (index % 9)],
        child: setListContent(index, scroll, isKeepAlive));
  }

  return Container(
      color: Colors.teal[100 * (index % 9)],
      height: 200,
      child: setListContent(index, scroll, isKeepAlive));
}

Widget setListContent(int index, ScrollController scroll, bool isKeepAlive) {
  if (index == taboolaWidgetIndex) {
    TaboolaClassicListener taboolaClassicListener = TaboolaClassicListener(
        taboolaDidResize,
        taboolaDidShow,
        taboolaDidFailToLoad,
        taboolaDidClickOnItem);

    TaboolaClassicUnit taboolaClassicUnit = taboolaClassicBuilder.build(
        PublisherProperties.placement_mid_article,
        PublisherProperties.mode_1x2_widget,
        false,
        taboolaClassicListener,
        viewId: 123,
        scrollController: scroll,
        keepAlive: isKeepAlive);
    return taboolaClassicUnit;
  }

  if (index == taboolaFeedIndex) {
    TaboolaClassicListener taboolaClassicListener2 = TaboolaClassicListener(
        taboolaDidResize,
        taboolaDidShow,
        taboolaDidFailToLoad,
        taboolaDidClickOnItem);

    TaboolaClassicUnit taboolaClassicfeed = taboolaClassicBuilder.build(
        PublisherProperties.placement,
        PublisherProperties.mode,
        true,
        taboolaClassicListener2,
        viewId: 123333,
        scrollController: scroll,
        keepAlive: isKeepAlive);
    return taboolaClassicfeed;
  }
  return Text('List item $index');
}

//Taboola Standard listeners
void taboolaDidShow(String placement) {
  print("taboolaDidShow");
}

void taboolaDidResize(String placement, double height) {
  print("publisher did get height $height");
}

void taboolaDidFailToLoad(String placement, String error) {
  print("publisher placement:$placement did fail with an error:$error");
}

bool taboolaDidClickOnItem(
    String placement, String itemId, String clickUrl, bool organic) {
  print(
      "publisher did click on item: $itemId with clickUrl: $clickUrl in placement: $placement of organic: $organic");
  if (organic) {
    //_showToast("Publisher opted to open click but didn't actually open it.");
    print("organic");
  } else {
    // _showToast("Publisher opted to open clicks but the item is Sponsored, SDK retains control.");
    print("SC");
  }
  return false;
}
