import Flutter
import UIKit

public class SwiftTaboolaSdkPlugin: NSObject, FlutterPlugin {
    private let taboola = Taboola()
    private let telephony = Telephony()
    private let packageInfo = TBLPackgeInfo()
    private let deviceInfo = TaboolaDeviceInfo()
    private let METHOD_IS_USER_OPT_OUT = "isUserOptOut"
    private let METHOD_GET_AD_OR_IDFA = "getAdIdOrIdfa"
    private let METHOD_GET_ISO_COUNTRY_CODE = "getIsoCountryCode"
    private let GET_ALL = "getAllPackageInfo"
    private let GET_IOS_DEVICE_INFO = "getIosDeviceInfo"
    private static let TABOOLA_SDK = "taboola_sdk"
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: TABOOLA_SDK, binaryMessenger: registrar.messenger())
        let instance = SwiftTaboolaSdkPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
    }
    
    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        switch call.method {
        case METHOD_IS_USER_OPT_OUT:
            result(taboola.isLimitedAdTrackingEnabled())
        case METHOD_GET_AD_OR_IDFA:
            result(taboola.getAdIdOrIdfa())
        case METHOD_GET_ISO_COUNTRY_CODE:
            result(telephony.getIsoCountryCode())
        case GET_ALL:
            result(packageInfo.getAll())
        case GET_IOS_DEVICE_INFO:
            result(deviceInfo.getDeviceInfo())
        default:
            result(FlutterError(code: "NOT_IMPLEMENTED",
                                message: nil,
                                details: nil))
            return
        }
    }
}
