//
//  TaboolaPackgeInfo.swift
//  taboola_sdk
//
//  Created by Daniel Frimet on 27/06/2023.
//

import Foundation
import CoreTelephony


public class TBLPackgeInfo: NSObject {
    
    private let appNameKey = "appName"
    private let packageNameKey = "packageName"
    private let versionKey = "version"
    
    public func getAll() -> [String : String?] {
        let mainBundle = Bundle.main
        
        let appName = mainBundle.object(forInfoDictionaryKey: "CFBundleDisplayName") as? String
        
        ?? mainBundle.object(forInfoDictionaryKey: "CFBundleName") as? String
        ?? nil
        
        let packageName = mainBundle.bundleIdentifier ?? nil
        
        let version = mainBundle.object(forInfoDictionaryKey: "CFBundleShortVersionString") as? String
        ?? nil
        
        return [
            appNameKey: appName,
            packageNameKey: packageName,
            versionKey: version,
        ]
        
    }
    
}
