/**
 A utility class for retrieving device information.
 
 This class provides methods to obtain information about the current device such as its model and the system version it's running on.
 */
import Foundation
import UIKit

public class TaboolaDeviceInfo: NSObject {
    /// A key representing the device model.
    private let model = "model"
    
    /// A key representing the system version of the device.
    private let systemVersion = "systemVersion"
    
    /**
     Retrieves device information.
     
     - Returns: A dictionary containing the device model and system version.
     */
    public func getDeviceInfo() -> [String : String] {
        let device = UIDevice.current
        return [
            model: device.model,
            systemVersion: device.systemVersion
        ]
    }
}
