import 'package:flutter/services.dart';
import 'package:taboola_sdk/utils/logger.dart';

class SdkDescriptor {
  static const String _sdkt = "Taboola Flutter SDK"; //sdkName
  static const String _versionNotFound = 'undefined';

  static String getSdkName() {
    return _sdkt;
  }

  static Future<String?> getSdkVersion() async {
    try {
      final _sdkv = _extractVersionFromPubspec();
      return _sdkv;
    } catch (e) {
      return _versionNotFound;
    }
  }

  static Future<String> _extractVersionFromPubspec() async {
    const String _pathToPubspec = 'packages/taboola_sdk/pubspec.yaml';
    final fileContent = await rootBundle.loadString(_pathToPubspec);
    final versionPattern = RegExp(r'^\s*version:\s*(\S+)', multiLine: true);
    final match = versionPattern.firstMatch(fileContent);

    if (match != null) {
      final version = match.group(1)?.trim();
      return version ?? _versionNotFound;
    } else {
      return _versionNotFound;
    }
  }
}
