import 'base_device.dart';

class IosDevice implements BaseDeviceInfo {
  const IosDevice({
    this.systemVersion,
    this.model,
  });

  final String? systemVersion;

  final String? model;
  static const String systemVersionKey = 'systemVersion';

  static IosDevice fromMap(Map<String, dynamic> map) {
    return IosDevice(
      systemVersion: map[systemVersionKey],
      model: map[BaseDeviceInfo.modelKey],
    );
  }

  @override
  Map<String, dynamic> toMap() {
    return {
      BaseDeviceInfo.modelKey: model,
      systemVersionKey: systemVersion,
    };
  }

  @override
  toString() {
    return 'IosDevice { model: $model, systemVersion: $systemVersion }';
  }
}
