import 'dart:async';
import 'package:taboola_sdk/native_plugin/taboola_package_info_platform_interface.dart';
export 'package:taboola_sdk/native_plugin/taboola_package_info_platform_interface.dart'
    show AndroidDevice, IosDevice;

class TaboolaDeviceInfo {
  TaboolaDeviceInfo();

  static TaboolaPackageInfoPlatform? __platform;

  static TaboolaPackageInfoPlatform get _platform {
    if (__platform == null) {
      __platform ??= TaboolaPackageInfoPlatform.instance;
    }

    return __platform!;
  }

  AndroidDevice? _cachedAndroidDeviceInfo;

  ///https://developer.android.com/reference/android/os/Build.html
  Future<AndroidDevice> get androidInfo async =>
      _cachedAndroidDeviceInfo ??= await _platform.androidInfo();

  IosDevice? _cachedIosDeviceInfo;

  ///https://developer.apple.com/documentation/uikit/uidevice
  Future<IosDevice> get iosInfo async =>
      _cachedIosDeviceInfo ??= await _platform.iosInfo();
}
