import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:taboola_sdk/native_plugin/taboola_package_info_data.dart';
import 'package:taboola_sdk/native_plugin/taboola_sdk_plugin.dart';

import 'android_device.dart';
import 'ios_device.dart';

export 'android_device.dart';
export 'ios_device.dart';



abstract class TaboolaPackageInfoPlatform extends PlatformInterface {
  TaboolaPackageInfoPlatform() : super(token: _token);

  static final Object _token = Object();

  static TaboolaPackageInfoPlatform _instance = TaboolaSdkPlugin();

  static TaboolaPackageInfoPlatform get instance => _instance;


  static set instance(TaboolaPackageInfoPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<TaboolaPackageInfoData> getAllPackageInfo() {
    throw UnimplementedError('getAllPackageInfo() has not been implemented.');
  }


  Future<AndroidDevice> androidInfo() {
    throw UnimplementedError('androidInfo() has not been implemented.');
  }


  Future<IosDevice> iosInfo() {
    throw UnimplementedError('iosInfo() has not been implemented.');
  }
}