import 'package:flutter/cupertino.dart';
import 'package:flutter_custom_tabs/flutter_custom_tabs.dart';
import 'package:webview_flutter/webview_flutter.dart';

// Import for Android features.
import 'package:webview_flutter_android/webview_flutter_android.dart';

// Import for iOS features.
import 'package:webview_flutter_wkwebview/webview_flutter_wkwebview.dart';
class WebviewUtils {
    static String  buildWebviewUrl(viewId,_publisherId, _mode,_pageType,_targetType,_pageId,_placement,_pageUrl) {
      return "https://cdn.taboola.com/shared/templateJS.html?"
          "publisher=${WebviewUtils._encodeParam(_publisherId)}"
          "&mode=${WebviewUtils._encodeParam(_mode)}"
          "&pageType=${WebviewUtils._encodeParam(_pageType)}"
          "&placement=${WebviewUtils._encodeParam(_placement)}"
          "&targetType=${WebviewUtils._encodeParam(_targetType)}"
          "&pageId=${WebviewUtils._encodeParam(_pageId)}"
          "&pageUrl=${WebviewUtils._encodeParam(_pageUrl)}"
          "&DIV_ID=taboola2"
          "&viewID=${_encodeParam(viewId.toString())}";
    }

    static void configWebViewControllerParams(WebViewController _webViewController) {
      final PlatformWebViewControllerCreationParams
      webKitWebViewControllerCreationParams;
      if (WebViewPlatform.instance is WebKitWebViewPlatform) {
        webKitWebViewControllerCreationParams =
            WebKitWebViewControllerCreationParams(
              allowsInlineMediaPlayback: true,
            );
      } else {
        webKitWebViewControllerCreationParams =
        const PlatformWebViewControllerCreationParams();
      }

      _webViewController = WebViewController.fromPlatformCreationParams(
          webKitWebViewControllerCreationParams);
      if (_webViewController.platform is AndroidWebViewController) {
        //Only Android needs the "Scroll switch" solution. iOS Implements a stretching WebView without inner scrolling.
        // _vertical = WebViewGestureRecognizer(widget); //..onUpdate = (_) {};

        AndroidWebViewController.enableDebugging(true);
        (_webViewController.platform as AndroidWebViewController)
            .setMediaPlaybackRequiresUserGesture(false);
      }
    }

    static String _encodeParam(String param) {
      return Uri.encodeFull(param);
    }


    //config for flutter_custom_tabs

    static CustomTabsOption ccTabConfig({Color? toolbarColor}) {
      return CustomTabsOption(
        toolbarColor: toolbarColor,
        enableDefaultShare: true,
        enableUrlBarHiding: true,
        showPageTitle: true,
      );
    }

    static SafariViewControllerOption safariViewControllerConfig({Color? primaryColor, Color? preferredControlTintColor}) {
      return SafariViewControllerOption(
        preferredBarTintColor: primaryColor,
        preferredControlTintColor: preferredControlTintColor,
        barCollapsingEnabled: true,
        entersReaderIfAvailable: false,
        dismissButtonStyle: SafariViewControllerDismissButtonStyle.done,
      );
    }
}